<?php
/**
 *  
 *
 *   ,   ,
 *    ,    .
 *
 * @author  Victor Grischenko <victor.grischenko@zveno.com.ua>
 * @package Bin
 * @since   25.07.2006
 */

require_once($_SERVER["DOCUMENT_ROOT"]."/etc/init.php");

CCore::import("cfPage");

$erCode = empty($_GET["ercode"]) ? "" : trim($_GET["ercode"]);

do {

    /*******************************************
     *
     *  
     *
     *******************************************/
    if ( !$oPage = cfPage::create() ) {
        CError::raise(CCore::lc("Page creation error"), __FILE__, __LINE__);
        break;
    }



    /*******************************************
     *
     *  
     *
     *******************************************/

    //   
    if (!$arErrors = parse_ini_file($_CONFIG["general.etcdir"]."/errors.ini", true)) {
        break;
    }

    $erHeader = "";
    $erTitle  = CCore::lc("Unknown error");
    $erMsg    = CCore::lc("Unknown error was occured.");

    if ( $oError = CCore::error_pop() ) {
        //   

        if ($_CONFIG["debug.show_runtime_errors"]) {
            //    
            CCore::error_push($oError);
            $erHeader = "";
            $erTitle  = CCore::lc("System error");
            $erMsg    = CCore::print_errors( false );
        }
        else {

            if (isset($arErrors[$oError->message])) {
                //     
                $erHeader = empty($arErrors[$oError->message]["header"]) ? "" : $arErrors[$oError->message]["header"];
                $erTitle  = $oError->message." ".$arErrors[$oError->message]["title"];
                $erMsg    = $arErrors[$oError->message]["message"];
            }
            else {
                //   
                //   404
                $erHeader  = empty($arErrors["404"]["header"]) ? "" : $arErrors["404"]["header"];
                $erTitle   = "404 ".$arErrors["404"]["title"];
                $erMsg     = $arErrors["404"]["message"];
            }
        }

    }
    elseif ( $erCode ) {

        //   
        do {

            if ( isset($arErrors[$erCode]) ) {
                //   
                $erHeader = empty($arErrors[$erCode]["header"]) ? "" : $arErrors[$erCode]["header"];
                $erTitle  = $erCode." ".$arErrors[$erCode]["title"];
                $erMsg    = $arErrors[$erCode]["message"];
            }

        } while (false);

    }

    if ( $erHeader ) {
        //   
        header($erHeader);
    }



    /*******************************************
     *
     * 
     *
     *******************************************/
    if (!$oPage->setTemplate($_CONFIG["general.tpldir"]."/bin/error.tpl.php")) {
        CError::raise(CCore::lc("Page creation error"), __FILE__, __LINE__);
        break;
    }

    $oPage->setTitle($erTitle);

    $oPage->addData("title",   $erTitle);
    $oPage->addData("message", $erMsg);

    $oPage->build();

} while (false);

//   
ob_end_clean();
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
    "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
<title>Fatal Error</title>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1251" />
<link rev="made" href="mailto:zenon@oberon.zveno" />
<style type="text/css">
<!--
body { color: #000000; background-color: #FFFFFF; }
a:link { color: #0000CC; }
-->
</style>
</head>

<body>
<h1>Fatal error</h1>
<p>Fatal error was occured.</p>
</body>
</html>
<?
exit;
?>
