<?
/**
 *   .
 *
 * @author  Victor Grischenko <victor.grischenko@zveno.com.ua>
 * @package Utils
 * @since   07.06.2006
*/


// 
require($_SERVER["DOCUMENT_ROOT"]."/etc/init.php");

require($_CONFIG["general.libdir"]."/cutils.php");
require($_CONFIG["general.coredir"]."/centity.php");
require($CFPARAMS["basedir"]."/interface/view/cfpage.class.php");



$entid    = empty($_GET["entid"])    ? 0     : (int)$_GET["entid"];
$field    = empty($_GET["field"])    ? ""    : trim($_GET["field"]);
$iwidth   = empty($_GET["iwidth"])   ? 0     : (int)$_GET["iwidth"];
$iheight  = empty($_GET["iheight"])  ? 0     : (int)$_GET["iheight"];
$realname = empty($_GET["realname"]) ? ""    : trim($_GET["realname"]);
$method   = empty($_GET["method"])   ? "box" : trim($_GET["method"]);



do {

    //   
    if ( !$oEnt = CEntity::create($entid) ) {
        CError::raise("Entity creation error", __FILE__, __LINE__);
        break;
    }

    if ( empty($oEnt->etype->fields_name[$field]) ) {
        CError::raise("Unknown field", __FILE__, __LINE__);
        break;
    }

    if ( $oEnt->etype->fields_name[$field]->params["field_type"] != "image" &&
         $oEnt->etype->fields_name[$field]->params["field_type"] != "file" ) {
        CError::raise("Unsupported field type", __FILE__, __LINE__);
        break;
    }

    $fname    = $_CONFIG["general.uploaddir"]."/".$oEnt->params[$field];
    $fcache   = $_CONFIG["general.cachedir"]."/thumbnails/".$oEnt->params[$field].".".$iwidth."x".$iheight."x".$method;
    $realname = $oEnt->params[$field."_realname"];



    // ,    cache/thumbnails
    if ( !file_exists($_CONFIG["general.cachedir"]."/thumbnails") ) {
        //   
        if ( !mkdir($_CONFIG["general.cachedir"]."/thumbnails") ) {
            CError::raise(CCore::lc("Cache directory creation error"), __FILE__, __LINE__);
            break;
        }
    }

    if ( $iheight > 250 || $iwidth > 250) {
        //     250x250px,
        //   404
        CError::raise("404", __FILE__, __LINE__);
        break;
    }

    if ( !file_exists($fcache) ) {

        //    ,  
        switch ( $method ) {

            case "cut":
                //     
                CUtils::make_thumbnail($fname, $fcache, $iwidth, $iheight );
                break;

            default:
                //    
                CUtils::make_thumbnail_box($fname, $fcache, $iwidth, $iheight );

        }

    }

    if ( !file_exists($fcache) ) {
        CError::raise("404", __FILE__, __LINE__);
        break;
    }

    //    
    if ( !$mimes = parse_ini_file($_CONFIG["general.etcdir"]."/mimes.ini") ) {
        $mime = "application/octet-stream";
    }
    else {
        $ext  = strtolower(CUtils::get_file_ext($realname));
        $mime = empty($mimes[$ext]) ? "application/octet-stream" : $mimes[$ext];
    }


    //  
    $modified = filemtime($fcache);
    CCore::update_last_modified($modified);

    $oPage = cfPage::create();
    $oPage->addHeader("Content-Type", $mime);

    //   
    if ( !empty($_CONFIG["webface.cache.client"]) ) {
        //   
        $oPage->processCacheHeaders( md5($modified) );
    }

    $oPage->sendHeaders();

    $fp = fopen($fcache, "r");
    fpassthru($fp);
    exit;

} while (false);

//  
include($_CONFIG["general.basedir"]."/bin/error.php");
?>